<?php
require_once('facebook_app.php');
require_once('config.php');
require_once('vb_api_client.php');

if(!(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strstr($_SERVER['HTTP_X_REQUESTED_WITH'], 'XMLHttpRequest'))) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

if( empty($_POST['username']) || empty($_POST['email']) || empty($_POST['password'])) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

$app = FacebookApp::instance();
$facebook = $app->getFacebookInterface();
$me = $facebook->api('/me');

$post['signed_request'] = $_POST['signed_request'];
$post['agree'] = 1;
$post['username'] = $_POST['username'];
$post['email'] = $_POST['email'];
$post['emailconfirm'] = $_POST['email'];
$post['password'] = $_POST['password'];
$post['passwordconfirm'] = $_POST['password'];
$post['fbname'] = $me['name'];
$post['fbuserid'] = $me['id'];

$results = json_decode(VBApiClient::instance()->call_cached("register_addmember", array(), $post), true);
error_log(json_encode($results));
$error_messages = array(
    'alreadyregistered' => array(true, false, 'This facebook account is already registered.'),
    'registeremail' => array(true, false, 'Registration successful, please check your email to activate.'),
    'moderateuser' => array(true, false, 'Registration successful, please allow time for a moderator to approve your account.'),
    'noregister' => array(false, true, 'This board is not currently accepting new members.'),
    'registration_complete' => array(true, false, 'Registration successful!'),
    'emailtaken' => array(false, true, 'That email is already taken!'),
    'bademail' => array(false, true, 'Please check to ensure you have entered a valid email address.'),
    'usernametaken' => array(false, true, 'That username is already taken!'),
    'usernametoolong' => array(false, true, 'That username is too long!'),
    'facebook_account_already_registered' => array(true, false, 'This facebook account is already registered.')
);   

if(isset($results['response']['errorlist'])) {
    $error_message = array();
    foreach($results['response']['errorlist'] as $error) {
        $error_return = @$error_messages[$error[0]];
        if(isset($error_return)) {
            $error_message[] = $error_return;
        } else {
            $error_message[] = array(false, true, $error[0]);
        }
    }
    $final_redirect = false;
    $final_error = true;
    $final_message = '';
    foreach($error_message as $error_return) {
        $final_redirect = $final_redirect || $error_return[0];
        $final_error = $final_error && $error_return[1];
        $final_message .= $error_return[2] . '<br/>';
    }
    echo json_encode(array("redirect" => $final_redirect, "error" => $final_error, "message" => $final_message));
} else if(isset($results['response']['errormessage'])) {
    $errormessage = $results['response']['errormessage'][0];
    $error_return = $error_messages[$errormessage];
    if(isset($error_return)) {
        echo json_encode(array("redirect" => $error_return[0], "error" => $error_return[1], "message" => $error_return[2]));
    } else {
        echo json_encode(array("redirect" => false, "error" => true, "message" => 'Unable to complete registration at this time, please try again later.'));
    }
} else {
     echo json_encode(array("redirect" => false, "error" => true, "message" => 'Unable to complete registration at this time, please try again later.'));
}
exit;
?>